/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2003 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2003 Matthew Kendora and
                            Brad Jorsch (anomie@users.sourceforge.net)
 

                      
  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and
                            Nach (n-a-c-h@users.sourceforge.net)
                                          
  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2003 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman (jweidman@slip.net),
                            neviksti (neviksti@hotmail.com), and
                            Kris Bleakley (stinkfish@bigpond.com)
 
  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2003 zsKnight, pagefault (pagefault@zsnes.com)
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar and Gary Henderson.



 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

/*******************************************************************************
  Snes9x custom (Snes9x for Mac OS) by zones
  
  This build was started from John Stiles' port.
*******************************************************************************/

#include "port.h"

#include <InputSprocket.h>
#include "os9-prefix.h"
#include "os9-os.h"
#include "os9-joypad.h"

const OSType	kSubCreatorCode	   = '0003';
const OSType	kSNES9XCreatorCode = '~9X~';

#define	k1PIconPad  		1201
#define	k1PIconUp			800
#define	k1PIconDown			801
#define	k1PIconLeft			802
#define	k1PIconRight		803
#define	k1PIconY			804
#define	k1PIconB			805
#define	k1PIconX			806
#define	k1PIconA			807
#define	k1PIconL			808
#define	k1PIconR			809
#define	k1PIconStart		810
#define	k1PIconSelect		811

#define	k2PIconPad 		    1202
#define	k2PIconUp			812
#define	k2PIconDown			813
#define	k2PIconLeft			814
#define	k2PIconRight		815
#define	k2PIconY			816
#define	k2PIconB			817
#define	k2PIconX			818
#define	k2PIconA			819
#define	k2PIconL			820
#define	k2PIconR			821
#define	k2PIconStart		822
#define	k2PIconSelect		823

#define	k3PIconPad 		    1203
#define	k3PIconUp			900
#define	k3PIconDown			901
#define	k3PIconLeft			902
#define	k3PIconRight		903
#define	k3PIconY			904
#define	k3PIconB			905
#define	k3PIconX			906
#define	k3PIconA			907
#define	k3PIconL			908
#define	k3PIconR			909
#define	k3PIconStart		910
#define	k3PIconSelect		911

#define	k4PIconPad 		    1204
#define	k4PIconUp			1000
#define	k4PIconDown			1001
#define	k4PIconLeft			1002
#define	k4PIconRight		1003
#define	k4PIconY			1004
#define	k4PIconB			1005
#define	k4PIconX			1006
#define	k4PIconA			1007
#define	k4PIconL			1008
#define	k4PIconR			1009
#define	k4PIconStart		1010
#define	k4PIconSelect		1011

#define	k5PIconPad 		    1205
#define	k5PIconUp			1100
#define	k5PIconDown			1101
#define	k5PIconLeft			1102
#define	k5PIconRight		1103
#define	k5PIconY			1104
#define	k5PIconB			1105
#define	k5PIconX			1106
#define	k5PIconA			1107
#define	k5PIconL			1108
#define	k5PIconR			1109
#define	k5PIconStart		1110
#define	k5PIconSelect		1111

#define	kIconFastForward	824
#define	kIconFreeze		    825
#define	kIconDefrost		826
#define kIconScreenshot     827
#define	kIconEsc			837
#define kIconSPC			828

#define kIconScopeT			829
#define kIconScopeP			830
#define kIconScopeC			831
	
#define kIconOffScreen		832

static ISpElementReference	gVirtualElements[kNeedCount];
static Boolean				hasInputSprocket = false;

static ISpNeed	gNeeds[kNeedCount] =
{
	{ "\p1P Pad",	    k1PIconPad,			1, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_XAxis,		0,	0,	0,	0 },
	{ "\p1P Pad",	    k1PIconPad,			1, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_YAxis,		0,	0,	0,	0 },
	{ "\p1P B Button", 	k1PIconB, 			1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p1P A Button", 	k1PIconA,			1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnRight,		0,	0,	0,	0 },
	{ "\p1P X Button", 	k1PIconX,			1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p1P Y Button",	k1PIconY, 			1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnLeft,		0,	0,	0,	0 },
	{ "\p1P L Button", 	k1PIconL,			1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p1P R Button",	k1PIconR,			1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },
	{ "\p1P Select",	k1PIconSelect,		1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_Select,		0,	0,	0,	0 },
	{ "\p1P Start",	  	k1PIconStart,		1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_StartPause,	0,	0,	0,	0 },
	{ "\p1P Up",	    k1PIconUp,			1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p1P Down",	    k1PIconDown,		1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p1P Left",	    k1PIconLeft,		1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p1P Right",	    k1PIconRight,		1, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },

	{ "\p2P Pad",	    k2PIconPad,			2, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_XAxis,		0,	0,	0,	0 },
	{ "\p2P Pad",	    k2PIconPad,			2, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_YAxis,		0,	0,	0,	0 },
	{ "\p2P B Button", 	k2PIconB, 			2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p2P A Button", 	k2PIconA,			2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnRight,		0,	0,	0,	0 },
	{ "\p2P X Button", 	k2PIconX,			2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p2P Y Button",	k2PIconY, 			2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnLeft,		0,	0,	0,	0 },
	{ "\p2P L Button", 	k2PIconL,			2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p2P R Button",	k2PIconR,			2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },
	{ "\p2P Select",	k2PIconSelect,		2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_Select,		0,	0,	0,	0 },
	{ "\p2P Start",	  	k2PIconStart,		2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_StartPause,	0,	0,	0,	0 },
	{ "\p2P Up",	    k2PIconUp,			2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p2P Down",	    k2PIconDown,		2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p2P Left",	    k2PIconLeft,		2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p2P Right",	    k2PIconRight,		2, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },
 
	{ "\p3P Pad",	    k3PIconPad,			3, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_XAxis,		0,	0,	0,	0 },
	{ "\p3P Pad",	    k3PIconPad,			3, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_YAxis,		0,	0,	0,	0 },
	{ "\p3P B Button", 	k3PIconB, 			3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p3P A Button", 	k3PIconA,			3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnRight,		0,	0,	0,	0 },
	{ "\p3P X Button", 	k3PIconX,			3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p3P Y Button",	k3PIconY, 			3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnLeft,		0,	0,	0,	0 },
	{ "\p3P L Button", 	k3PIconL,			3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p3P R Button",	k3PIconR,			3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },
	{ "\p3P Select",	k3PIconSelect,		3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_Select,		0,	0,	0,	0 },
	{ "\p3P Start",	  	k3PIconStart,		3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_StartPause,	0,	0,	0,	0 },
	{ "\p3P Up",	    k3PIconUp,			3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p3P Down",	    k3PIconDown,		3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p3P Left",	    k3PIconLeft,		3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p3P Right",	    k3PIconRight,		3, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },

	{ "\p4P Pad",	    k4PIconPad,			4, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_XAxis,		0,	0,	0,	0 },
	{ "\p4P Pad",	    k4PIconPad,			4, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_YAxis,		0,	0,	0,	0 },
	{ "\p4P B Button", 	k4PIconB, 			4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p4P A Button", 	k4PIconA,			4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnRight,		0,	0,	0,	0 },
	{ "\p4P X Button", 	k4PIconX,			4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p4P Y Button",	k4PIconY, 			4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnLeft,		0,	0,	0,	0 },
	{ "\p4P L Button", 	k4PIconL,			4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p4P R Button",	k4PIconR,			4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },
	{ "\p4P Select",	k4PIconSelect,		4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_Select,		0,	0,	0,	0 },
	{ "\p4P Start",	  	k4PIconStart,		4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_StartPause,	0,	0,	0,	0 },
	{ "\p4P Up",	    k4PIconUp,			4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p4P Down",	    k4PIconDown,		4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p4P Left",	    k4PIconLeft,		4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p4P Right",	    k4PIconRight,		4, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },

	{ "\p5P Pad",	    k5PIconPad,			5, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_XAxis,		0,	0,	0,	0 },
	{ "\p5P Pad",	    k5PIconPad,			5, 0,	kISpElementKind_Axis,		kISpElementLabel_Axis_YAxis,		0,	0,	0,	0 },
	{ "\p5P B Button", 	k5PIconB, 			5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p5P A Button", 	k5PIconA,			5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnRight,		0,	0,	0,	0 },
	{ "\p5P X Button", 	k5PIconX,			5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p5P Y Button",	k5PIconY, 			5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_TurnLeft,		0,	0,	0,	0 },
	{ "\p5P L Button", 	k5PIconL,			5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p5P R Button",	k5PIconR,			5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },
	{ "\p5P Select",	k5PIconSelect,		5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_Select,		0,	0,	0,	0 },
	{ "\p5P Start",	  	k5PIconStart,		5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_StartPause,	0,	0,	0,	0 },
	{ "\p5P Up",	    k5PIconUp,			5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveForward,	0,	0,	0,	0 },
	{ "\p5P Down",	    k5PIconDown,		5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_MoveBackward,	0,	0,	0,	0 },
	{ "\p5P Left",	    k5PIconLeft,		5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideLeft,		0,	0,	0,	0 },
	{ "\p5P Right",	    k5PIconRight,		5, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_SlideRight,	0,	0,	0,	0 },

	{ "\pFast Forward",	kIconFastForward,	0, 0,	kISpElementKind_Button,		kISpElementLabel_None,				0,	0,	0,	0 },
	{ "\pFreeze Game", 	kIconFreeze,		0, 0,	kISpElementKind_Button,		kISpElementLabel_None,				0,	0,	0,	0 },
	{ "\pDefrost Game",	kIconDefrost,		0, 0,	kISpElementKind_Button,		kISpElementLabel_None,				0,	0,	0,	0 },
	{ "\pScreenshot",   kIconScreenshot,    0, 0,   kISpElementKind_Button,     kISpElementLabel_None,              0,  0,  0,  0 },	
	{ "\pBreak",		kIconEsc,			0, 0,	kISpElementKind_Button,		kISpElementLabel_Btn_StartPause,	0,	0,	0,	0 },
	{ "\pSPC",			kIconSPC,			0, 0,	kISpElementKind_Button,		kISpElementLabel_None,				0,	0,	0,	0 },

	{ "\pScope Turbo",	kIconScopeT,		0, 0,	kISpElementKind_Button,		kISpElementLabel_None,				0,	0,	0,	0 },
	{ "\pScope Pause",	kIconScopeP,		0, 0,	kISpElementKind_Button,		kISpElementLabel_None,				0,	0,	0,	0 },
	{ "\pScope Cursor",	kIconScopeC,		0, 0,	kISpElementKind_Button,		kISpElementLabel_None,				0,	0,	0,	0 },
	
	{ "\pOffscreen",	kIconOffScreen,		0, 0,	kISpElementKind_Button,		kISpElementLabel_None,				0,	0,	0,	0 }
};

void SetUpHID(void)
{
	hasInputSprocket = ((Ptr) ISpInit != (Ptr) kUnresolvedCFragSymbolAddress);
	
	if (hasInputSprocket)
	{
		for (int count = 0; count < kNeedCount; count++)
			gVirtualElements[count] = nil;
			
		ISpElement_NewVirtualFromNeeds(kNeedCount, gNeeds, gVirtualElements, 0);
		
		ISpInit(kNeedCount,	gNeeds,	gVirtualElements, kSNES9XCreatorCode, kSubCreatorCode, 0, 128, 0);
		
		hidExist = true;
	}
	else
		hidExist = false;
}

void ReleaseHID(void)
{
	if (hasInputSprocket)
		ISpStop();
}

void ConfigureHID(void)
{
	if (hasInputSprocket)
		ISpConfigure(nil);
}

long ISpKeyIsPressed(short needID)
{
	UInt32 state = 0;
	
	ISpElement_GetSimpleState(gVirtualElements[needID], &state);
	
	return (long) state;
}

OSStatus Load_Config(void)
{
	return noErr;
}

OSStatus Save_Config(void)
{
	return noErr;
}

void ClearPadSetting(void)
{
	return;
}

void JoypadScanDirection(int p, uint32 *pad)
{
	const unsigned int	lowAverage  = (kISpAxisMiddle / 2 + kISpAxisMinimum / 2),
						highAverage = (kISpAxisMiddle / 2 + kISpAxisMaximum / 2);
	
	switch (p)
	{
		case 0:
			if (ISpKeyIsPressed(kISp1PXAxis) > highAverage) *pad |= 0x0100;
			if (ISpKeyIsPressed(kISp1PXAxis) < lowAverage ) *pad |= 0x0200;
			if (ISpKeyIsPressed(kISp1PYAxis) < lowAverage ) *pad |= 0x0400;
			if (ISpKeyIsPressed(kISp1PYAxis) > highAverage) *pad |= 0x0800;
			if (ISpKeyIsPressed(kISp1PRt))					*pad |= 0x0100;
			if (ISpKeyIsPressed(kISp1PLf)) 					*pad |= 0x0200;
			if (ISpKeyIsPressed(kISp1PDn)) 					*pad |= 0x0400;
			if (ISpKeyIsPressed(kISp1PUp)) 					*pad |= 0x0800;
			break;

		case 1:
			if (ISpKeyIsPressed(kISp2PXAxis) > highAverage) *pad |= 0x0100;
			if (ISpKeyIsPressed(kISp2PXAxis) < lowAverage ) *pad |= 0x0200;
			if (ISpKeyIsPressed(kISp2PYAxis) < lowAverage ) *pad |= 0x0400;
			if (ISpKeyIsPressed(kISp2PYAxis) > highAverage) *pad |= 0x0800;
			if (ISpKeyIsPressed(kISp2PRt))					*pad |= 0x0100;
			if (ISpKeyIsPressed(kISp2PLf)) 					*pad |= 0x0200;
			if (ISpKeyIsPressed(kISp2PDn)) 					*pad |= 0x0400;
			if (ISpKeyIsPressed(kISp2PUp)) 					*pad |= 0x0800;
			break;

		case 2:
			if (ISpKeyIsPressed(kISp3PXAxis) > highAverage) *pad |= 0x0100;
			if (ISpKeyIsPressed(kISp3PXAxis) < lowAverage ) *pad |= 0x0200;
			if (ISpKeyIsPressed(kISp3PYAxis) < lowAverage ) *pad |= 0x0400;
			if (ISpKeyIsPressed(kISp3PYAxis) > highAverage) *pad |= 0x0800;
			if (ISpKeyIsPressed(kISp3PRt))					*pad |= 0x0100;
			if (ISpKeyIsPressed(kISp3PLf)) 					*pad |= 0x0200;
			if (ISpKeyIsPressed(kISp3PDn)) 					*pad |= 0x0400;
			if (ISpKeyIsPressed(kISp3PUp)) 					*pad |= 0x0800;
			break;

		case 3:
			if (ISpKeyIsPressed(kISp4PXAxis) > highAverage) *pad |= 0x0100;
			if (ISpKeyIsPressed(kISp4PXAxis) < lowAverage ) *pad |= 0x0200;
			if (ISpKeyIsPressed(kISp4PYAxis) < lowAverage ) *pad |= 0x0400;
			if (ISpKeyIsPressed(kISp4PYAxis) > highAverage) *pad |= 0x0800;
			if (ISpKeyIsPressed(kISp4PRt))					*pad |= 0x0100;
			if (ISpKeyIsPressed(kISp4PLf)) 					*pad |= 0x0200;
			if (ISpKeyIsPressed(kISp4PDn)) 					*pad |= 0x0400;
			if (ISpKeyIsPressed(kISp4PUp)) 					*pad |= 0x0800;
			break;

		case 4:
			if (ISpKeyIsPressed(kISp5PXAxis) > highAverage) *pad |= 0x0100;
			if (ISpKeyIsPressed(kISp5PXAxis) < lowAverage ) *pad |= 0x0200;
			if (ISpKeyIsPressed(kISp5PYAxis) < lowAverage ) *pad |= 0x0400;
			if (ISpKeyIsPressed(kISp5PYAxis) > highAverage) *pad |= 0x0800;
			if (ISpKeyIsPressed(kISp5PRt))					*pad |= 0x0100;
			if (ISpKeyIsPressed(kISp5PLf)) 					*pad |= 0x0200;
			if (ISpKeyIsPressed(kISp5PDn)) 					*pad |= 0x0400;
			if (ISpKeyIsPressed(kISp5PUp)) 					*pad |= 0x0800;
	}
}	
